﻿-- addon name and localization table

local a,L=...

-- create frames

local DCL=CreateFrame('frame',a)
local DCLPanel=CreateFrame('frame',a..'Panel')
DCL:RegisterEvent('PLAYER_LOGIN')

-- initialize variables

Decliner_SV={}
local _
local dcldebug
local DCLD={}
local DCLD_OnHide
local DCLD_OnShow
local DCL_SetLFGFrame
local DCL_SetPetitionFrame
local DCL_SetStaticPopup
local DCL_SetTradeFrame
local g='|cff00ff00'
local gsnd={group,guild,}
local invrequest
local invtrack={}
local msglist={}
local msgtimer
local notemp=true
local numbutton=0
local numtext=0
local oldSFX
local player
local plrlist={}
local plrtimer
local r='|cffff0000'
local selfwarn
local SPD_={}
local temp={}
local tradeinitiated
local uiinfo={['d']={},['p']={},['t']={},}
local vars={}
local file={
	['ch']='Interface\\RaidFrame\\ReadyCheck-Ready',
	['cr']='Interface\\RaidFrame\\ReadyCheck-NotReady',
}
local defs={
	enable={duel=true,pet=true,guild=true,group=true,chart=true,trade=true,chan=true,},
	tell={duel=false,pet=false,guild=false,group=false,chart=false,trade=false,chan=false,},
	group={duel=false,pet=false,guild=false,group=false,chart=false,trade=false,chan=false,},
	guild={duel=false,pet=false,guild=false,group=false,chart=false,trade=false,chan=false,},
	friend={duel=false,pet=false,guild=false,group=false,chart=false,trade=false,chan=false,},
	bnet={duel=false,pet=false,guild=false,group=false,chart=false,trade=false,chan=false,},
	msg={duel=false,pet=false,guild=false,group=false,chart=false,trade=false,chan=false,},
	chan={emote=true,say=true,yell=true,[1]=true,[2]=true,[26]=true,},
	gen={openinv=false,msgs=false,disable=false,},
	open={'invite','portal',},
}

function DCL:Debug(message,...)
	if not dcldebug then return end
	local args={n=select('#',...),...}
	local argstr=''
	for i=1,args.n do
		if argstr == '' then argstr=' args: '..tostring(args[i])..''
		else argstr=''..argstr..', '..tostring(args[i])..'' end
	end
	DCL:Print('debug ('..message..')'..argstr..'',true)
end

-- global string strip
-- originally from Phanx

function DCL:Pattern(str)
	str=gsub(str,'|H.-|h.-|h','') -- removes player links
	str=gsub(str,'%%%d?$?s','') -- removes %s
	str=gsub(str,':','') -- removes colons
	str=gsub(str,'%(','') -- removes (
	str=gsub(str,'%)','') -- removes )
	str=gsub(str,'%.','') -- removes periods
	str=gsub(str,'^%s','') -- removes leftover space from beginning of string
	str=gsub(str,'%s$','') -- removes leftover space from end of string
	return str
end

-- Blizzard global strings used, with enUS in comments. parts in quotes are raw strings before DCL:Pattern.
-- this table is only here to keep strings in one place. it's inefficient to do this, especially since some of these are used once.

local S={
	ADR=ADD..'/'..REMOVE,                                                                                 --  Add/Remove
	BNF=BATTLENET_OPTIONS_LABEL..' '..FRIENDS,                                                            --  Battle.net Friends
	CHA=CHANNEL,                                                                                          --  Channel
	CHS=CHANNELS,                                                                                         --  Channels
	DCA=DCL:Pattern(ERR_DUEL_CANCELLED),                                                                  -- "Duel cancelled."
	DDA=DISABLE..' '..a,                                                                                  --  Disable Decliner
	DDM=DISABLE..' '..PLAYER_MESSAGES,                                                                    --  Disable Player Messages
	DOI=DISABLE..' '..OPENING..' '..GROUP..' '..DCL:Pattern(GUILDEVENT_TYPE_INVITE):gsub("^%l",strupper), --  Disable Opening Group "%s invites %s"
	DRE=DCL:Pattern(DUEL_REQUESTED),                                                                      -- "%s has challenged you to a duel."
	DUE=DUEL,                                                                                             --  Duel
	EDE=ENABLE..' '..DECLINE,                                                                             --  Enable Decline
	EMO=EMOTE,                                                                                            --  Emote
	GEN=GENERAL,                                                                                          --  General
	GLD=GUILD,                                                                                            --  Guild
	GME=GUILD..' '..MEMBERS,                                                                              --  Guild Members
	GRE=DCL:Pattern(ERR_INVITED_ALREADY_IN_GROUP_SS),                                                     -- "|Hplayer:%s|h[%s]|h invited you to a group, but you could not accept because you are already in a group."
	GRI=DCL:Pattern(ERR_INVITED_TO_GROUP_SS),                                                             -- "|Hplayer:%s|h[%s]|h has invited you to join a group."
	GRO=GROUP,                                                                                            --  Group
	GRM=GROUP..' '..MEMBERS,                                                                              --  Group Members
	GUI=DCL:Pattern(ERR_INVITED_TO_GUILD_SSS),                                                            -- "|Hplayer:%s|h[%s]|h invites you to join %s."
	INV=DCL:Pattern(GUILDEVENT_TYPE_INVITE):gsub("^%l",strupper),                                         -- "%s invites %s"
	LFG=LFG_TITLE,                                                                                        --  Looking For Group
	PBA=PET_BATTLE_PVP_QUEUE,                                                                             --  Pet Battle
	PBD=DCL:Pattern(ERR_PETBATTLE_DECLINED),                                                              -- "Pet battle invitation declined."
	PBR=DCL:Pattern(PET_BATTLE_PVP_DUEL_REQUESTED),                                                       -- "%s has challenged you to a pet-battle."
	PLM=PLAYER_MESSAGES,                                                                                  --  Player Messages
	PTN=DCL:Pattern(PETITION_TITLE),                                                                      -- "Petition: %s"
	REA=strlower(READY),                                                                                  --  Ready
	REQ=GUILDINFOTAB_APPLICANTS_NONE,                                                                     --  Requests
	RFR=DCL:Pattern(FRIENDS_LIST_REALM)..' '..FRIENDS,                                                    -- "Realm: %s" Friends
	SAY=SAY,                                                                                              --  Say
	TCA=DCL:Pattern(ERR_TRADE_CANCELLED),                                                                 -- "Trade cancelled."
	TIN=DCL:Pattern(ERR_INITIATE_TRADE_S),                                                                -- "You have requested to trade with %s."
	TRA=TRADE,                                                                                            --  Trade
	VER=strlower(GAME_VERSION_LABEL),                                                                     --  Version
	WHI=DCL:Pattern(AUTOCOMPLETE_LABEL_INTERACTED),                                                       -- "(Whispered)"
	YEL=YELL,                                                                                             --  Yell

	DRM=gsub(DUEL_REQUESTED,'%%%d?$?s',''),                                                               --  special string to gsub duel message down to character name in chat filter
	PBM=gsub(PET_BATTLE_PVP_DUEL_REQUESTED,'%%%d?$?s',''),                                                --  special string to gsub pet duel message down to character name in chat filter
}

-- timer to control open invites, chat messages, and list of whispered players

function DCL:Timer(str)
	if str == 'inv' then
		tinsert(invtrack,'track')
		C_Timer.After(300,function()
			if #invtrack == 1 then
				DCL:Debug('5 minutes since last trigger, invites closed')
				invrequest=false
				invtrack={}
			else
				DCL:Debug('invites still open due to multiple triggers')
				tremove(invtrack,1)
			end
		end)
	elseif str == 'msg' then
		msgtimer=true
		C_Timer.After(60,function()
			DCL:Debug('"'..msglist[1]..'" cleared from spam')
			tremove(msglist,1)
			if next(msglist) ~= nil then DCL:Timer('msg')
			else msgtimer=false end
		end)
	elseif str == 'plr' then
		plrtimer=true
		C_Timer.After(60,function()
			DCL:Debug("|Hplayer:"..plrlist[1].."|h["..plrlist[1].."]|h no longer authorized")
			tremove(plrlist,1)
			if next(plrlist) ~= nil then DCL:Timer('plr')
			else plrtimer=false end
		end)
	end
end

-- chat output
-- the idea for faking a yellow system message came from Jaliborc's Scrap
-- but they hook into the MessageHandler function while I use AddMessage

function DCL:Print(message,dbg)
	if vars.gen.disable or vars.gen.msgs then return end
	if next(msglist) ~= nil then
		for k,v in next,msglist do
			if message == v and not dcldebug then return end
		end
	end
	if not selfwarn and not dbg then
		tinsert(msglist,message)
		if not msgtimer then DCL:Timer('msg') end
	end selfwarn=false
	local info,notfound=ChatTypeInfo['SYSTEM'],true
	for i=1,NUM_CHAT_WINDOWS do
		if _G['ChatFrame'..i]:IsEventRegistered('CHAT_MSG_SYSTEM') then
			notfound=false
			_G['ChatFrame'..i]:AddMessage(r..a..': |r'..message,info.r,info.g,info.b,info.id)
		end
	end
	if notfound then DEFAULT_CHAT_FRAME:AddMessage(r..a..': |r'..message,info.r,info.g,info.b,info.id) end
end

-- main bouncer, which ultimately decides if a player is declined
-- this function is global, usage:

---- DeclinerAllowed('name')

-- returns true if
---- you recently whispered 'name', they're in your group, in your guild, your friend, or on bnet
-- returns false if
---- they are a complete stranger

-- if you want to check 'name' against a specific event using Decliner's settings:

---- DeclinerAllowed('name','option')

-- where 'option' can be 'duel', 'pet', 'guild', 'group', 'chart', 'trade', or 'chan'

-- make sure 'name' and 'option' is surrounded with single or double quotes
-- for example: DeclinerAllowed('Mcstabyrogue','duel') or DeclinerAllowed("Palylight")

function DeclinerAllowed(name,option,dbgsup)
	name=Ambiguate(name,'short')
	local bypass
	if option ~= nil then
		for k in next,defs.enable do
			if option == k then
				bypass=false
				if vars.gen.disable or not vars.enable[option] then
				if not dbgsup then DCL:Debug('allowed - option disabled',name,option) end
				return true end
			end
		end
	else bypass=true end
	if bypass or not vars.tell[option] then
		if next(plrlist) ~= nil then
			for k,v in next,plrlist do
				if name == v then
				if not dbgsup then DCL:Debug('allowed - whispered',name,option) end
				return true end
			end
		end
	end
	if bypass or (option ~= 'group' and IsInGroup() and not vars.group[option]) then
		if IsInRaid() then
			for i=1,MAX_RAID_MEMBERS do
				if (UnitName('raid'..i)) ~= nil then
					if name == Ambiguate((UnitName('raid'..i)),'short') then
					if not dbgsup then DCL:Debug('allowed - raid member',name,option) end
					return true end
				end
			end
		else
			for i=1,GetNumGroupMembers() do
				if name == Ambiguate((UnitName('party'..i)),'short') then
				if not dbgsup then DCL:Debug('allowed - party member',name,option) end
				return true end
			end
		end
	end
	if bypass or (option ~= 'guild' and IsInGuild() and not vars.guild[option]) then
		for i=1,(GetNumGuildMembers()) do
			if name == Ambiguate((GetGuildRosterInfo(i)),'short') then
			if not dbgsup then DCL:Debug('allowed - guild member',name,option) end
			return true end
		end
	end
	if bypass or not vars.friend[option] then
		for i=1,(GetNumFriends()) do
			if name == Ambiguate((GetFriendInfo(i)),'short') then
			if not dbgsup then DCL:Debug('allowed - realm friend',name,option) end
			return true end
		end
	end
	if bypass or not vars.bnet[option] then
		for i=1,(BNGetNumFriends()) do
			for j=1,(BNGetNumFriendGameAccounts(i)) do
				local _,charname,client=BNGetFriendGameAccountInfo(i,j)
				if client == 'WoW' then
					if name == Ambiguate(charname,'short') then
					if not dbgsup then DCL:Debug('allowed - battle.net friend',name,option) end
					return true end
				end
			end
		end
	end
	if not dbgsup then DCL:Debug('declined',name,option) end
	return false
end

-- allows all group invites 5 minutes after player last said certain words
-- changing zones or joining a group will cancel this effect
-- being in a group will not trigger this effect

function DCL:OpenInvite(message,sender)
	if vars.gen.openinv or IsInGroup() or sender ~= player then return end
	for k,v in next,vars.open do
		if strmatch(message,'^'..v..'$')
		or strmatch(message,'^'..v..'[^%w].*')
		or strmatch(message,'.*[^%w]'..v..'$')
		or strmatch(message,'^.*[^%w]'..v..'[^%w].*$') then
			DCL:Debug('invites are open due to "'..message..'"')
			invrequest=true
			DCL:Timer('inv')
		end
	end
end

-- following function from http://lua-users.org/wiki/CopyTable
-- this copies the values of a table into another table instead of creating a reference

local function tcopy(src)
	local copy
	if type(src) == 'table' then
		copy={}
		for k,v in next,src do
			copy[tcopy(k)]=tcopy(v)
		end
		setmetatable(copy,tcopy(getmetatable(src)))
	else copy=src end
	return copy
end

-- event blocks

function DCL:PLAYER_LOGIN()
	local name,realm=UnitFullName('player')
	player=name..'-'..realm
	GuildRoster()
	ShowFriends()
	oldSFX=GetCVar('Sound_EnableSFX')
	SPD_['DUEL_REQUESTED']=tcopy(StaticPopupDialogs['DUEL_REQUESTED'])
	SPD_['PET_BATTLE_PVP_DUEL_REQUESTED']=tcopy(StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED'])
	SPD_['PARTY_INVITE']=tcopy(StaticPopupDialogs['PARTY_INVITE'])
	SPD_['PARTY_INVITE_XREALM']=tcopy(StaticPopupDialogs['PARTY_INVITE_XREALM'])
	SPD_['CHAT_CHANNEL_INVITE']=tcopy(StaticPopupDialogs['CHAT_CHANNEL_INVITE'])
	if Decliner_SV.check then
		for k1,v1 in next,defs do
			if Decliner_SV[k1] == nil then
				Decliner_SV[k1]=defs[k1]
				vars[k1]=defs[k1]
			else
				vars[k1]=Decliner_SV[k1]
			end
			for k2 in next,v1 do
				if Decliner_SV[k1][k2] == nil then
					Decliner_SV[k1][k2]=defs[k1][k2]
					vars[k1][k2]=defs[k1][k2]
				elseif type(Decliner_SV[k1][k2]) ~= 'boolean' and type(k2) == 'boolean' then
					Decliner_SV[k1][k2]=defs[k1][k2]
					vars[k1][k2]=defs[k1][k2]
				else
					vars[k1][k2]=Decliner_SV[k1][k2]
				end
			end
		end
		Decliner_SV=nil
		Decliner_SV=tcopy(vars)
		Decliner_SV.check=true
	else
		vars=tcopy(defs)
		Decliner_SV=nil
		Decliner_SV=tcopy(defs)
		Decliner_SV.check=true
	end
	DCL:BlizzCode()
	DCL:BlizzOptions()
	DCL:Options()
	DCL:Register()
	DCL:Print(S['VER']..' '..GetAddOnMetadata(a,'Version')..' '..S['REA'])
	DCL:UnregisterEvent('PLAYER_LOGIN')
end

function DCL:CHAT_MSG_CHANNEL(message,sender,_,_,_,_,ID)
	if vars.chan[ID] then DCL:OpenInvite(message,sender) end
end

function DCL:CHAT_MSG_EMOTE(message,sender)
	if vars.chan.emote then DCL:OpenInvite(message,sender) end
end

function DCL:CHAT_MSG_SAY(message,sender)
	if vars.chan.say then DCL:OpenInvite(message,sender) end
end

function DCL:CHAT_MSG_YELL(message,sender)
	if vars.chan.yell then DCL:OpenInvite(message,sender) end
end

function DCL:GROUP_ROSTER_UPDATE()
	if invrequest then DCL:Debug('you joined a group, invites closed') end
	invrequest=false
end

function DCL:ZONE_CHANGED_NEW_AREA()
	if invrequest then DCL:Debug('you entered a new zone, invites closed') end
	invrequest=false
end

function DCL:CHAT_MSG_SYSTEM(message)
	if strmatch(message,S['TIN']) then
		DCL:Debug('you opened your own trade window')
		tradeinitiated=true
	end
end

function DCL:TRADE_CLOSED()
	if tradeinitiated then DCL:Debug('you closed your own trade window') end
	tradeinitiated=false
end

function DCL:CHAT_MSG_WHISPER_INFORM(_,name)
	DCL:Debug("|Hplayer:"..name.."|h["..name.."]|h is now authorized")
	tinsert(plrlist,Ambiguate(name,'short'))
	if not plrtimer then DCL:Timer('plr') end
end

function DCL:CVAR_UPDATE(cvar,value)
	oldSFX=GetCVar('Sound_EnableSFX')
	if cvar == 'BLOCK_TRADES' then
		if value == '0' and not vars.enable.trade then
			vars.enable.trade=true
			DCL:Register()
			DCL:SetCheckBoxes()
			DCL:BlizzOptions()
			selfwarn=true
			DCL:Print(L['X_BLOCK_TRADES_OFF'])
		end
		if value == '1' and vars.enable.trade then
			vars.enable.trade=false
			DCL:Register()
			DCL:SetCheckBoxes()
			DCL:BlizzOptions()
			selfwarn=true
			DCL:Print(L['X_BLOCK_TRADES_ON'])
		end
	end
	if cvar == 'BLOCK_CHAT_CHANNEL_INVITE' then
		if value == '0' and not vars.enable.chan then
			vars.enable.chan=true
			DCL:Register()
			DCL:SetCheckBoxes()
			DCL:BlizzOptions()
			selfwarn=true
			DCL:Print(L['X_BLOCK_CHANNELS_OFF'])
		end
		if value == '1' and vars.enable.chan then
			vars.enable.chan=false
			DCL:Register()
			DCL:SetCheckBoxes()
			DCL:BlizzOptions()
			selfwarn=true
			DCL:Print(L['X_BLOCK_CHANNELS_ON'])
		end
	end
end

function DCL:DISABLE_DECLINE_GUILD_INVITE()
	if vars.enable.guild then return end
	vars.enable.guild=true
	DCL:Register()
	DCL:SetCheckBoxes()
	DCL:BlizzOptions()
	selfwarn=true
	DCL:Print(L['X_BLOCK_GUILDS_OFF'])
end

function DCL:ENABLE_DECLINE_GUILD_INVITE()
	if not vars.enable.guild then return end
	vars.enable.guild=false
	DCL:Register()
	DCL:SetCheckBoxes()
	DCL:BlizzOptions()
	selfwarn=true
	DCL:Print(L['X_BLOCK_GUILDS_ON'])
end

function DCL:DUEL_REQUESTED(...)
	local _,frame=StaticPopup_Visible('DUEL_REQUESTED')
	if frame then HideUIPanel(frame) end
	local name=...
	tinsert(uiinfo['d'],1,name)
	DCL:Debug('DUEL',...)
	if DeclinerAllowed(name,'duel') then
		if frame then
			DCL_SetStaticPopup(frame,'default')
			ShowUIPanel(frame)
			PlaySoundKitID(880)
		end
	else
		CancelDuel()
		if not vars.msg.duel then
			DCL:Print(format(L['DECLINED_DUEL'],"|Hplayer:"..name.."|h["..name.."]|h"))
		end
	end
end

function DCL:PET_BATTLE_PVP_DUEL_REQUESTED(...)
	local _,frame=StaticPopup_Visible('PET_BATTLE_PVP_DUEL_REQUESTED')
	if frame then HideUIPanel(frame) end
	local name=...
	tinsert(uiinfo['p'],1,name)
	DCL:Debug('PET',...)
	if DeclinerAllowed(name,'pet') then
		if frame then
			DCL_SetStaticPopup(frame,'default')
			ShowUIPanel(frame)
			PlaySoundKitID(880)
		end
	else
		C_PetBattles.CancelPVPDuel()
		if not vars.msg.pet then
			DCL:Print(format(L['DECLINED_PET'],"|Hplayer:"..name.."|h["..name.."]|h"))
		end
	end
end

function DCL:GUILD_INVITE_REQUEST(...)
	SetCVar('Sound_EnableSFX','0')
	local name,guild=...
	DCL:Debug('GUILD',...)
	if DeclinerAllowed(name,'guild') then
		C_Timer.After(0.5,function()
			SetCVar('Sound_EnableSFX',oldSFX)
			PlaySoundKitID(888)
		end)
	else
		StaticPopupSpecial_Hide(GuildInviteFrame)
		DeclineGuild()
		if not vars.msg.guild then
			DCL:Print(format(L['DECLINED_GUILD'],"|Hplayer:"..name.."|h["..name.."]|h",guild))
		end
		C_Timer.After(0.5,function()SetCVar('Sound_EnableSFX',oldSFX)end)
	end
end

function DCL:PARTY_INVITE_REQUEST(...)
	local name,lfg1,lfg2,lfg3,xrlm=...
	local which=xrlm and 'PARTY_INVITE_XREALM' or 'PARTY_INVITE'
	local _,frame=StaticPopup_Visible(which)
	if frame then HideUIPanel(frame) end
	if lfg1 or lfg2 or lfg3 then LFGInvitePopup:Hide() end
	DCL:Debug('GROUP',...)
	if invrequest or DeclinerAllowed(name,'group') then
		if frame then
			DCL_SetStaticPopup(frame,'default')
			ShowUIPanel(frame)
			PlaySoundKitID(880)
			StaticPopupDialogs[which].OnHide=function(self)
				if not self.inviteAccepted then
					DeclineGroup()
					self:Hide()
				end
				StaticPopupDialogs[which]=tcopy(DCLD[which])
			end
		elseif lfg1 or lfg2 or lfg3 then
			DCL_SetLFGFrame('default')
			LFGInvitePopup:Show()
		end
	else
		DeclineGroup()
		if not vars.msg.group then
			DCL:Print(format(L['DECLINED_GROUP'],"|Hplayer:"..name.."|h["..name.."]|h"))
		end
	end
end

function DCL:PETITION_SHOW(...)
	HideUIPanel(PetitionFrame)
	local ptype,_,_,_,name,originator=GetPetitionInfo()
	DCL:Debug('CHART',...)
	if originator or DeclinerAllowed(name,'chart') then
		DCL_SetPetitionFrame('default')
		ShowUIPanel(PetitionFrame)
	else
		ClosePetition()
		if not vars.msg.chart then
			if ptype == 'guild' then
				DCL:Print(format(L['DECLINED_CHART_GUILD'],"|Hplayer:"..name.."|h["..name.."]|h"))
			else
				DCL:Print(format(L['DECLINED_CHART_NIL'],"|Hplayer:"..name.."|h["..name.."]|h"))
			end
		end
	end
end

function DCL:TRADE_SHOW(...)
	HideUIPanel(TradeFrame)
	-- thank you to http://wowprogramming.com/docs/api_types#unitID for that vague Trade UI note next to 'npc'
	local name,realm=UnitName('npc')
	if realm then name=name..'-'..realm end
	tinsert(uiinfo['t'],1,name)
	DCL:Debug('TRADE',name,...)
	if tradeinitiated or DeclinerAllowed(name,'trade') then
		DCL_SetTradeFrame('default')
		ShowUIPanel(TradeFrame)
	else
		CloseTrade()
		if not vars.msg.trade then
			DCL:Print(format(L['DECLINED_TRADE'],"|Hplayer:"..name.."|h["..name.."]|h"))
		end
	end
end

function DCL:CHANNEL_INVITE_REQUEST(...)
	local _,frame=StaticPopup_Visible('CHAT_CHANNEL_INVITE')
	if frame then HideUIPanel(frame) end
	local chan,name=...
	DCL:Debug('CHAN',...)
	if DeclinerAllowed(name,'chan') then
		if frame then
			DCL_SetStaticPopup(frame,'default')
			ShowUIPanel(frame)
		end
	else
		DeclineChannelInvite(chan)
		if not vars.msg.chan then
			DCL:Print(format(L['DECLINED_CHAN'],"|Hplayer:"..name.."|h["..name.."]|h",chan))
		end
	end
end

function DCL:UI_INFO_MESSAGE(arg1,arg2)
	if vars.gen.disable then return end
	local msg=arg2 or arg1 -- WoD uses arg1 for the message, Legion uses arg2 with an unknown number in arg1
	if strmatch(msg,S['DCA']) and uiinfo['d'][1] ~= nil and vars.enable.duel then
		if not DeclinerAllowed(uiinfo['d'][1],'duel',true) then UIErrorsFrame:Clear() end
		tremove(uiinfo['d'],1)
	end
	if strmatch(msg,S['PBD']) and uiinfo['p'][1] ~= nil and vars.enable.pet then
		if not DeclinerAllowed(uiinfo['p'][1],'pet',true) then UIErrorsFrame:Clear() end
		tremove(uiinfo['p'],1)
	end
	if strmatch(msg,S['TCA']) and uiinfo['t'][1] ~= nil and vars.enable.trade then
		if not DeclinerAllowed(uiinfo['t'][1],'trade',true) and not tradeinitiated then UIErrorsFrame:Clear() end
		tremove(uiinfo['t'],1)
	end
end

-- this line calls functions named after registered events

DCL:SetScript('OnEvent',function(self,event,...)self[event](self,...)end)

-- all Blizzard code wrapped in one function

function DCL:BlizzCode()

-- chat filter that blocks associated system messages if that action is declined

	DECLINER_CHAT_FILTER=function(_,_,msg)
		if vars.gen.disable then return end
		if strmatch(msg,S['DRE']) and vars.enable.duel then
			local name=gsub(msg,S['DRM'],'')
			if not DeclinerAllowed(name,'duel',true) then return true end
		end
		if strmatch(msg,S['PBR']) and vars.enable.pet then
			local name=gsub(msg,S['PBM'],'')
			if not DeclinerAllowed(name,'pet',true) then return true end
		end
		if strmatch(msg,S['GUI']) and vars.enable.guild then
			local name=strmatch(msg,'|h%[(.-)%]|h')
			if not DeclinerAllowed(name,'guild',true) then return true end
		end
		if strmatch(msg,S['GRI']) and vars.enable.group then
			local name=strmatch(msg,'|h%[(.-)%]|h')
			if not DeclinerAllowed(name,'group',true) then return true end
		end
		if strmatch(msg,S['GRE']) and vars.enable.group then
			local name=strmatch(msg,'|h%[(.-)%]|h')
			if not DeclinerAllowed(name,'group',true) then return true end
		end
	end
	ChatFrame_AddMessageEventFilter('CHAT_MSG_SYSTEM',DECLINER_CHAT_FILTER)

-- begin Blizzard code replacements (these are injected into the UI, so direct usage of global strings the UI uses instead of S table)
-- all of these are basically alterations of Blizzard's Lua or changing Blizzard's frame scripts
-- you can view Blizzard's Lua with these instructions: http://wow.gamepedia.com/Viewing_Blizzard's_interface_code

	DCLD['DUEL_REQUESTED']={
		text=DUEL_REQUESTED,
		button1=ACCEPT,
		button2=DECLINE,
		OnAccept=function(self)
			AcceptDuel()
		end,
		OnCancel=function(self)
			CancelDuel()
		end,
		timeout=STATICPOPUP_TIMEOUT,
		hideOnEscape=1
	}

	DCLD['PET_BATTLE_PVP_DUEL_REQUESTED']={
		text=PET_BATTLE_PVP_DUEL_REQUESTED,
		button1=ACCEPT,
		button2=DECLINE,
		OnAccept=function(self)
			C_PetBattles.AcceptPVPDuel()
		end,
		OnCancel=function(self)
			C_PetBattles.CancelPVPDuel()
		end,
		timeout=STATICPOPUP_TIMEOUT,
		hideOnEscape=1
	}

	DCLD['PARTY_INVITE']={
		text=INVITATION,
		button1=ACCEPT,
		button2=DECLINE,
		OnShow=function(self)
			self.inviteAccepted=nil
		end,
		OnAccept=function(self)
			AcceptGroup()
			self.inviteAccepted=1
		end,
		OnCancel=function(self)
			DeclineGroup()
		end,
		OnHide=function(self)
			if (not self.inviteAccepted) then
				self:Hide()
			end
		end,
		timeout=STATICPOPUP_TIMEOUT,
		whileDead=1,
		hideOnEscape=1
	}

	DCLD['PARTY_INVITE_XREALM']={
		text=INVITATION_XREALM,
		button1=ACCEPT,
		button2=DECLINE,
		OnShow=function(self)
			self.inviteAccepted=nil
		end,
		OnAccept=function(self)
			AcceptGroup()
			self.inviteAccepted=1
		end,
		OnCancel=function(self)
			DeclineGroup()
		end,
		OnHide=function(self)
			if (not self.inviteAccepted) then
				self:Hide()
			end
		end,
		timeout=STATICPOPUP_TIMEOUT,
		whileDead=1,
		hideOnEscape=1
	}

	DCLD['CHAT_CHANNEL_INVITE']={
		text=CHAT_INVITE_NOTICE_POPUP,
		button1=ACCEPT,
		button2=DECLINE,
		OnShow=function(self)
			StaticPopupDialogs['CHAT_CHANNEL_INVITE'].inviteAccepted=nil
		end,
		OnAccept=function(self,data)
			local name=data
			local zoneChannel,channelName=JoinPermanentChannel(name,nil,DEFAULT_CHAT_FRAME:GetID(),1)
			if (channelName) then
				name=channelName
			end
			if (not zoneChannel) then
				return
			end
			local i=1
			while (DEFAULT_CHAT_FRAME.channelList[i]) do
				i=i+1
			end
			DEFAULT_CHAT_FRAME.channelList[i]=name
			DEFAULT_CHAT_FRAME.zoneChannelList[i]=zoneChannel
		end,
		EditBoxOnEnterPressed=function(self,data)
			local name=data
			local zoneChannel,channelName=JoinPermanentChannel(name,nil,DEFAULT_CHAT_FRAME:GetID(),1)
			if (channelName) then
				name=channelName
			end
			if (not zoneChannel) then
				return
			end
			local i=1
			while (DEFAULT_CHAT_FRAME.channelList[i]) do
				i=i+1
			end
			DEFAULT_CHAT_FRAME.channelList[i]=name
			DEFAULT_CHAT_FRAME.zoneChannelList[i]=zoneChannel
			StaticPopupDialogs['CHAT_CHANNEL_INVITE'].inviteAccepted=1
			self:GetParent():Hide()
		end,
		EditBoxOnEscapePressed=function(self,data)
			self:GetParent():Hide()
		end,
		OnCancel=function(self,data)
			local chanName=data
			DeclineChannelInvite(chanName)
		end,
		timeout=CHANNEL_INVITE_TIMEOUT,
		whileDead=1,
		hideOnEscape=1,
	}

	DCLD_OnShow=function(frame)
		local dialog=frame.which
		if dialog and
		((dialog == 'DUEL_REQUESTED' and vars.enable.duel) or
		(dialog == 'PET_BATTLE_PVP_DUEL_REQUESTED' and vars.enable.pet) or
		((dialog == 'PARTY_INVITE' or dialog == 'PARTY_INVITE_XREALM') and vars.enable.group)) or
		(dialog == 'CHAT_CHANNEL_INVITE' and vars.enable.chan) then
			local OnShow=dialog.OnShow
			if (OnShow) then
				OnShow(frame,frame.data)
			end
			if (dialog.enterClicksFirstButton) then
				frame:SetScript('OnKeyDown',StaticPopup_OnKeyDown)
			end
		else
			StaticPopup_OnShow(frame)
		end
	end

	DCLD_OnHide=function(frame)
		local dialog=frame.which
		if dialog and
		((dialog == 'DUEL_REQUESTED' and vars.enable.duel) or
		(dialog == 'PET_BATTLE_PVP_DUEL_REQUESTED' and vars.enable.pet) or
		((dialog == 'PARTY_INVITE' or dialog == 'PARTY_INVITE_XREALM') and vars.enable.group)) or
		(dialog == 'CHAT_CHANNEL_INVITE' and vars.enable.chan) then
			StaticPopup_CollapseTable()
			local OnHide=dialog.OnHide
			if (OnHide) then
				OnHide(frame,frame.data)
			end
			if (dialog.enterClicksFirstButton) then
				frame:SetScript('OnKeyDown',nil)
			end
		else
			StaticPopup_OnHide(frame)
		end
	end

	DCL_SetStaticPopup=function(frame,action)
		frame:SetScript('OnShow',nil)
		frame:SetScript('OnHide',nil)
		if action == 'decline' then
			frame:SetScript('OnShow',function()
				DCLD_OnShow(frame)
			end)
			frame:SetScript('OnHide',function()
				DCLD_OnHide(frame)
			end)
		elseif action == 'default' and vars.gen.disable then
			frame:SetScript('OnShow',function()
				StaticPopup_OnShow(frame)
			end)
			frame:SetScript('OnHide',function()
				StaticPopup_OnHide(frame)
			end)
		elseif action == 'default' then
			frame:SetScript('OnShow',function()
				StaticPopup_OnShow(frame)
			end)
			frame:SetScript('OnHide',function()
				StaticPopup_OnHide(frame)
				if vars.enable.duel or vars.enable.pet or vars.enable.group or vars.enable.chan then
					DCL_SetStaticPopup(frame,'decline')
				end
			end)
		end
	end

	DCL_SetLFGFrame=function(action)
		LFGInvitePopup:SetScript('OnShow',nil)
		LFGInvitePopup:SetScript('OnHide',nil)
		if action == 'default' and vars.gen.disable then
			LFGInvitePopup:SetScript('OnShow',function()
				PlaySoundKitID(880)
			end)
			LFGInvitePopup:SetScript('OnHide',function()
				PlaySoundKitID(851)
			end)
		elseif action == 'default' then
			LFGInvitePopup:SetScript('OnShow',function()
				PlaySoundKitID(880)
			end)
			LFGInvitePopup:SetScript('OnHide',function()
				PlaySoundKitID(851)
				if vars.enable.group then DCL_SetLFGFrame('decline') end
			end)
		end
	end

	DCL_SetPetitionFrame=function(action)
		PetitionFrame:SetScript('OnShow',nil)
		PetitionFrame:SetScript('OnHide',nil)
		if action == 'decline' then
			PetitionFrame:SetScript('OnHide',function()
				StaticPopup_Hide('CONFIRM_GUILD_CHARTER_SIGNATURE')
			end)
		elseif action == 'default' and vars.gen.disable then
			PetitionFrame:SetScript('OnShow',function()
				PlaySoundKitID(875)
			end)
			PetitionFrame:SetScript('OnHide',function()
				PlaySoundKitID(876)
				StaticPopup_Hide('CONFIRM_GUILD_CHARTER_SIGNATURE')
				ClosePetition()
			end)
		elseif action == 'default' then
			PetitionFrame:SetScript('OnShow',function()
				PlaySoundKitID(875)
			end)
			PetitionFrame:SetScript('OnHide',function()
				PlaySoundKitID(876)
				StaticPopup_Hide('CONFIRM_GUILD_CHARTER_SIGNATURE')
				ClosePetition()
				if vars.enable.chart then DCL_SetPetitionFrame('decline') end
			end)
		end
	end

	DCL_SetTradeFrame=function(action)
		TradeFrame:SetScript('OnShow',nil)
		TradeFrame:SetScript('OnHide',nil)
		if action == 'decline' then
			TradeFrame:SetScript('OnShow',function()
				TradeFrame_OnShow(self)
			end)
			TradeFrame:SetScript('OnHide',function()
				MoneyInputFrame_SetCopper(TradePlayerInputMoneyFrame,0)
			end)
		elseif action == 'default' and vars.gen.disable then
			TradeFrame:SetScript('OnShow',function()
				TradeFrame_OnShow(self)
				PlaySoundKitID(839)
			end)
			TradeFrame:SetScript('OnHide',function()
				TradeFrame_OnHide()
				PlaySoundKitID(840)
			end)
		elseif action == 'default' then
			TradeFrame:SetScript('OnShow',function()
				TradeFrame_OnShow(self)
				PlaySoundKitID(839)
			end)
			TradeFrame:SetScript('OnHide',function()
				TradeFrame_OnHide()
				PlaySoundKitID(840)
				if vars.enable.trade then DCL_SetTradeFrame('decline') end
			end)
		end
	end

end

-- event registration

function DCL:Register()
	if vars.gen.disable then
		DCL:UnregisterAllEvents()
		StaticPopupDialogs['DUEL_REQUESTED']=tcopy(SPD_['DUEL_REQUESTED'])
		StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']=tcopy(SPD_['PET_BATTLE_PVP_DUEL_REQUESTED'])
		StaticPopupDialogs['PARTY_INVITE']=tcopy(SPD_['PARTY_INVITE'])
		StaticPopupDialogs['PARTY_INVITE_XREALM']=tcopy(SPD_['PARTY_INVITE_XREALM'])
		StaticPopupDialogs['CHAT_CHANNEL_INVITE']=tcopy(SPD_['CHAT_CHANNEL_INVITE'])
		DCL_SetLFGFrame('default')
		DCL_SetPetitionFrame('default')
		DCL_SetTradeFrame('default')
		for i=1,STATICPOPUP_NUMDIALOGS do
			DCL_SetStaticPopup(_G['StaticPopup'..i],'default')
		end
		for i=1,21 do
			_G[a..'Text'..format('%02i',i)]:SetFontObject('GameFontDisableSmall')
		end
		for i=1,51 do
			_G[a..'Button'..format('%02i',i)]:Disable()
			_G[a..'Button'..format('%02i',i)..'Text']:SetFontObject('GameFontDisableSmall')
		end
		_G[a..'Button52'..'Text']:SetFontObject('GameFontNormalLarge')
		_G[a..'Header']:SetFontObject('GameFontDisableLarge')
	else
		DCL:RegisterEvent('CHAT_MSG_CHANNEL')
		DCL:RegisterEvent('CHAT_MSG_EMOTE')
		DCL:RegisterEvent('CHAT_MSG_SAY')
		DCL:RegisterEvent('CHAT_MSG_YELL')
		DCL:RegisterEvent('GROUP_ROSTER_UPDATE')
		DCL:RegisterEvent('ZONE_CHANGED_NEW_AREA')
		DCL:RegisterEvent('CHAT_MSG_SYSTEM')
		DCL:RegisterEvent('CHAT_MSG_WHISPER_INFORM')
		DCL:RegisterEvent('CVAR_UPDATE')
		DCL:RegisterEvent('DISABLE_DECLINE_GUILD_INVITE')
		DCL:RegisterEvent('ENABLE_DECLINE_GUILD_INVITE')
		if vars.enable.duel then
			DCL:RegisterEvent('DUEL_REQUESTED')
			StaticPopupDialogs['DUEL_REQUESTED']=tcopy(DCLD['DUEL_REQUESTED'])
		else
			DCL:UnregisterEvent('DUEL_REQUESTED')
			StaticPopupDialogs['DUEL_REQUESTED']=tcopy(SPD_['DUEL_REQUESTED'])
		end
		if vars.enable.pet then
			DCL:RegisterEvent('PET_BATTLE_PVP_DUEL_REQUESTED')
			StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']=tcopy(DCLD['PET_BATTLE_PVP_DUEL_REQUESTED'])
		else
			DCL:UnregisterEvent('PET_BATTLE_PVP_DUEL_REQUESTED')
			StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']=tcopy(SPD_['PET_BATTLE_PVP_DUEL_REQUESTED'])
		end
		if vars.enable.guild then
			DCL:RegisterEvent('GUILD_INVITE_REQUEST')
		else
			DCL:UnregisterEvent('GUILD_INVITE_REQUEST')
		end
		if vars.enable.group then
			DCL:RegisterEvent('PARTY_INVITE_REQUEST')
			StaticPopupDialogs['PARTY_INVITE']=tcopy(DCLD['PARTY_INVITE'])
			StaticPopupDialogs['PARTY_INVITE_XREALM']=tcopy(DCLD['PARTY_INVITE_XREALM'])
			DCL_SetLFGFrame('decline')
		else
			DCL:UnregisterEvent('PARTY_INVITE_REQUEST')
			StaticPopupDialogs['PARTY_INVITE']=tcopy(SPD_['PARTY_INVITE'])
			StaticPopupDialogs['PARTY_INVITE_XREALM']=tcopy(SPD_['PARTY_INVITE_XREALM'])
			DCL_SetLFGFrame('default')
		end
		if vars.enable.chart then
			DCL:RegisterEvent('PETITION_SHOW')
			DCL_SetPetitionFrame('decline')
		else
			DCL:UnregisterEvent('PETITION_SHOW')
			DCL_SetPetitionFrame('default')
		end
		if vars.enable.trade then
			DCL:RegisterEvent('TRADE_SHOW')
			DCL:RegisterEvent('TRADE_CLOSED')
			DCL_SetTradeFrame('decline')
		else
			DCL:UnregisterEvent('TRADE_SHOW')
			DCL:UnregisterEvent('TRADE_CLOSED')
			DCL_SetTradeFrame('default')
		end
		if vars.enable.chan then
			DCL:RegisterEvent('CHANNEL_INVITE_REQUEST')
			StaticPopupDialogs['CHAT_CHANNEL_INVITE']=tcopy(DCLD['CHAT_CHANNEL_INVITE'])
		else
			DCL:UnregisterEvent('CHANNEL_INVITE_REQUEST')
			StaticPopupDialogs['CHAT_CHANNEL_INVITE']=tcopy(SPD_['CHAT_CHANNEL_INVITE'])
		end
		if vars.enable.duel or vars.enable.pet or vars.enable.trade then
			DCL:RegisterEvent('UI_INFO_MESSAGE')
		else
			DCL:UnregisterEvent('UI_INFO_MESSAGE')
		end
		if vars.enable.duel or vars.enable.pet or vars.enable.group or vars.enable.chan then
			for i=1,STATICPOPUP_NUMDIALOGS do
				DCL_SetStaticPopup(_G['StaticPopup'..i],'decline')
			end
		else
			for i=1,STATICPOPUP_NUMDIALOGS do
				DCL_SetStaticPopup(_G['StaticPopup'..i],'default')
			end
		end
		for i=1,21 do
			_G[a..'Text'..format('%02i',i)]:SetFontObject('GameFontHighlightSmall')
		end
		for i=1,52 do
			_G[a..'Button'..format('%02i',i)]:Enable()
			_G[a..'Button'..format('%02i',i)..'Text']:SetFontObject('GameFontHighlightSmall')
		end
		_G[a..'Header']:SetFontObject('GameFontNormalLarge')
	end
	if vars.gen.disable or vars.gen.msgs then
		_G[a..'Text21']:SetFontObject('GameFontDisableSmall')
		for i=43,49 do
			_G[a..'Button'..i]:Disable()
		end
	else
		_G[a..'Text21']:SetFontObject('GameFontHighlightSmall')
		for i=43,49 do
			_G[a..'Button'..i]:Enable()
		end
	end
	if vars.gen.disable or vars.gen.openinv then
		DCLoptionOIinput:Disable()
		DCLoptionOIlist:Disable()
		DCLoptionOIbutton:Disable()
		UIDropDownMenu_DisableDropDown(DCLoptionOIdrop)
		DCLoptionOIinput:SetFontObject('GameFontDisableSmall')
		DCLoptionOIlist:SetFontObject('GameFontDisableSmall')
	else
		DCLoptionOIinput:Enable()
		DCLoptionOIlist:Enable()
		DCLoptionOIbutton:Enable()
		UIDropDownMenu_EnableDropDown(DCLoptionOIdrop)
		DCLoptionOIinput:SetFontObject('GameFontHighlightSmall')
		DCLoptionOIlist:SetFontObject('GameFontHighlightSmall')
	end
end

-- disables the block trades, block guild invites, and block channel invites options and edits their display text based on user options
-- Decliner won't be able to let authorized players through if these options are enabled

function DCL:BlizzOptions()
	if tostring(format('%4$s',GetBuildInfo())) ~= '60200' then DCL:BlizzOptionsLegion() else
		if vars.enable.trade and not vars.gen.disable then
			_G['InterfaceOptionsControlsPanelBlockTradesText']:SetFontObject('GameFontDisableLeft')
			_G['InterfaceOptionsControlsPanelBlockTradesText']:SetText(BLOCK_TRADES..' ('..a..')')
			SetCVar('blockTrades','0')
		else
			_G['InterfaceOptionsControlsPanelBlockTradesText']:SetFontObject('GameFontHighlightLeft')
			_G['InterfaceOptionsControlsPanelBlockTradesText']:SetText(BLOCK_TRADES)
		end
		if vars.enable.guild and not vars.gen.disable then
			_G['InterfaceOptionsControlsPanelBlockGuildInvitesText']:SetFontObject('GameFontDisableLeft')
			_G['InterfaceOptionsControlsPanelBlockGuildInvitesText']:SetText(BLOCK_GUILD_INVITES..' ('..a..')')
			SetAutoDeclineGuildInvites(false)
		else
			_G['InterfaceOptionsControlsPanelBlockGuildInvitesText']:SetFontObject('GameFontHighlightLeft')
			_G['InterfaceOptionsControlsPanelBlockGuildInvitesText']:SetText(BLOCK_GUILD_INVITES)
		end
		if vars.enable.chan and not vars.gen.disable then
			_G['InterfaceOptionsControlsPanelBlockChatChannelInvitesText']:SetFontObject('GameFontDisableLeft')
			_G['InterfaceOptionsControlsPanelBlockChatChannelInvitesText']:SetText(BLOCK_CHAT_CHANNEL_INVITE..' ('..a..')')
			SetCVar('blockChannelInvites','0')
		else
			_G['InterfaceOptionsControlsPanelBlockChatChannelInvitesText']:SetFontObject('GameFontHighlightLeft')
			_G['InterfaceOptionsControlsPanelBlockChatChannelInvitesText']:SetText(BLOCK_CHAT_CHANNEL_INVITE)
		end
	end
end

-- WoD's options are in the Controls panel, Legion's options are in the Social panel

function DCL:BlizzOptionsLegion()
	if vars.enable.trade and not vars.gen.disable then
		_G['InterfaceOptionsSocialPanelBlockTradesText']:SetFontObject('GameFontDisableLeft')
		_G['InterfaceOptionsSocialPanelBlockTradesText']:SetText(BLOCK_TRADES..' ('..a..')')
		SetCVar('blockTrades','0')
	else
		_G['InterfaceOptionsSocialPanelBlockTradesText']:SetFontObject('GameFontHighlightLeft')
		_G['InterfaceOptionsSocialPanelBlockTradesText']:SetText(BLOCK_TRADES)
	end
	if vars.enable.guild and not vars.gen.disable then
		_G['InterfaceOptionsSocialPanelBlockGuildInvitesText']:SetFontObject('GameFontDisableLeft')
		_G['InterfaceOptionsSocialPanelBlockGuildInvitesText']:SetText(BLOCK_GUILD_INVITES..' ('..a..')')
		SetAutoDeclineGuildInvites(false)
	else
		_G['InterfaceOptionsSocialPanelBlockGuildInvitesText']:SetFontObject('GameFontHighlightLeft')
		_G['InterfaceOptionsSocialPanelBlockGuildInvitesText']:SetText(BLOCK_GUILD_INVITES)
	end
	if vars.enable.chan and not vars.gen.disable then
		_G['InterfaceOptionsSocialPanelBlockChatChannelInvitesText']:SetFontObject('GameFontDisableLeft')
		_G['InterfaceOptionsSocialPanelBlockChatChannelInvitesText']:SetText(BLOCK_CHAT_CHANNEL_INVITE..' ('..a..')')
		SetCVar('blockChannelInvites','0')
	else
		_G['InterfaceOptionsSocialPanelBlockChatChannelInvitesText']:SetFontObject('GameFontHighlightLeft')
		_G['InterfaceOptionsSocialPanelBlockChatChannelInvitesText']:SetText(BLOCK_CHAT_CHANNEL_INVITE)
	end
end

-- Interface Options panel
-- I would like to thank FlexYourHead of the addon Work_Complete for a ton of comments in their code
-- It made understanding buttons, text, and the options frame a whole lot easier

function DCL:Create(obj,xloc,yloc,misc,text,image,rinset)
	if obj == 'b' then
		numbutton=numbutton+1
		local name=a..'Button'..format('%02i',numbutton)
		obj=CreateFrame('CheckButton',name,DCLPanel,'OptionsCheckButtonTemplate')
		obj:SetPoint('CENTER',DCLPanel,'TOPRIGHT',xloc,yloc)
		obj:SetHitRectInsets(-10,rinset or -10,-10,-10)
		obj:SetCheckedTexture(file[image])
		obj:SetDisabledCheckedTexture(file[image])
		obj:GetCheckedTexture():SetVertexColor(0.8,0.8,0.8)
		local supported=obj:GetDisabledCheckedTexture():SetDesaturated(true)
		if not supported then obj:GetDisabledCheckedTexture():SetAlpha(0.4) end
		obj:GetDisabledCheckedTexture():SetVertexColor(0.4,0.4,0.4)
		obj.tooltipText=misc
		_G[name..'Text']:SetFontObject('GameFontHighlightSmall')
		_G[name..'Text']:SetText(text)
	elseif obj == 't' then
		numtext=numtext+1
		local name=a..'Text'..format('%02i',numtext)
		obj=DCLPanel:CreateFontString(name,'ARTWORK','GameFontHighlightSmall')
		obj:SetPoint(misc,DCLPanel,'TOPRIGHT',xloc,yloc)
		obj:SetText(text)
	end
	return obj
end

function DCL:SetOpenInvList()
	table.sort(vars.open)
	local text
	for i=1,#vars.open do
		if not text then text=vars.open[i]
		else text=text..'\n'..vars.open[i] end
	end
	_G[''..a..'OpenInvList']:SetText(text or '')
end

function DCL:SetCheckBoxes()
	for k1,v1 in next,defs do
		for k2 in next,v1 do
			if k1 ~= 'chan' and k1 ~= 'open' then
				_G['DCLoption'..k1..k2]:SetChecked(vars[k1][k2])
			end
		end
	end
end

function DCL:Options()
	DCLPanel.name=a
	InterfaceOptions_AddCategory(DCLPanel,a)
	DCLoptionheader01=DCLPanel:CreateFontString(a..'Header','ARTWORK','GameFontNormalLarge')
	DCLoptionheader01:SetPoint('TOPLEFT',16,-16)
	DCLoptionheader01:SetText(a)
	DCLoptionline01=DCLPanel:CreateTexture(a..'Separator1')
	DCLoptionline01:SetSize(600,1)
	DCLoptionline01:SetPoint('LEFT',DCLPanel,'TOPLEFT',10,-40)
	if tostring(format('%4$s',GetBuildInfo())) ~= '60200' then
	DCLoptionline01:SetColorTexture(0.25,0.25,0.25) else
	DCLoptionline01:SetTexture(0.25,0.25,0.25) end -- WoD uses SetTexture, Legion uses SetColorTexture
	DCLoptionline02=DCLPanel:CreateTexture(a..'Separator2')
	DCLoptionline02:SetSize(600,1)
	DCLoptionline02:SetPoint('LEFT',DCLPanel,'TOPLEFT',10,-428)
	if tostring(format('%4$s',GetBuildInfo())) ~= '60200' then
	DCLoptionline02:SetColorTexture(0.25,0.25,0.25) else
	DCLoptionline02:SetTexture(0.25,0.25,0.25) end -- WoD uses SetTexture, Legion uses SetColorTexture
	DCLoptiontext01=DCL:Create('t',-460,-64,'CENTER',S['DUE'])
	DCLoptiontext02=DCL:Create('t',-460,-80,'CENTER',S['REQ'])
	DCLoptiontext03=DCL:Create('t',-392,-64,'CENTER',S['PBA'])
	DCLoptiontext04=DCL:Create('t',-392,-80,'CENTER',S['REQ'])
	DCLoptiontext05=DCL:Create('t',-324,-64,'CENTER',S['GLD'])
	DCLoptiontext06=DCL:Create('t',-324,-80,'CENTER',S['INV'])
	DCLoptiontext07=DCL:Create('t',-256,-64,'CENTER',S['GRO'])
	DCLoptiontext08=DCL:Create('t',-256,-80,'CENTER',S['INV'])
	DCLoptiontext09=DCL:Create('t',-188,-64,'CENTER',S['GLD'])
	DCLoptiontext10=DCL:Create('t',-188,-80,'CENTER',S['PTN'])
	DCLoptiontext11=DCL:Create('t',-120,-64,'CENTER',S['TRA'])
	DCLoptiontext12=DCL:Create('t',-120,-80,'CENTER',S['REQ'])
	DCLoptiontext13=DCL:Create('t',-52,-64,'CENTER',S['CHA'])
	DCLoptiontext14=DCL:Create('t',-52,-80,'CENTER',S['INV'])
	DCLoptiontext15=DCL:Create('t',-492,-112,'RIGHT',S['EDE'])
	DCLoptiontext16=DCL:Create('t',-492,-160,'RIGHT',S['WHI'])
	DCLoptiontext17=DCL:Create('t',-492,-208,'RIGHT',S['GRM'])
	DCLoptiontext18=DCL:Create('t',-492,-256,'RIGHT',S['GME'])
	DCLoptiontext19=DCL:Create('t',-492,-304,'RIGHT',S['RFR'])
	DCLoptiontext20=DCL:Create('t',-492,-352,'RIGHT',S['BNF'])
	DCLoptiontext21=DCL:Create('t',-492,-400,'RIGHT',S['PLM'])
	DCLoptionenableduel=DCL:Create('b',-460,-112,g..L['ENABLE_DUEL'],'','ch')
	DCLoptionenablepet=DCL:Create('b',-392,-112,g..L['ENABLE_PET'],'','ch')
	DCLoptionenableguild=DCL:Create('b',-324,-112,g..L['ENABLE_GUILD'],'','ch')
	DCLoptionenablegroup=DCL:Create('b',-256,-112,g..L['ENABLE_GROUP'],'','ch')
	DCLoptionenablechart=DCL:Create('b',-188,-112,g..L['ENABLE_CHART'],'','ch')
	DCLoptionenabletrade=DCL:Create('b',-120,-112,g..L['ENABLE_TRADE'],'','ch')
	DCLoptionenablechan=DCL:Create('b',-52,-112,g..L['ENABLE_CHAN'],'','ch')
	DCLoptiontellduel=DCL:Create('b',-460,-160,r..L['TELL_DUEL'],'','cr')
	DCLoptiontellpet=DCL:Create('b',-392,-160,r..L['TELL_PET'],'','cr')
	DCLoptiontellguild=DCL:Create('b',-324,-160,r..L['TELL_GUILD'],'','cr')
	DCLoptiontellgroup=DCL:Create('b',-256,-160,r..L['TELL_GROUP'],'','cr')
	DCLoptiontellchart=DCL:Create('b',-188,-160,r..L['TELL_CHART'],'','cr')
	DCLoptiontelltrade=DCL:Create('b',-120,-160,r..L['TELL_TRADE'],'','cr')
	DCLoptiontellchan=DCL:Create('b',-52,-160,r..L['TELL_CHAN'],'','cr')
	DCLoptiongroupduel=DCL:Create('b',-460,-208,r..L['GROUP_DUEL'],'','cr')
	DCLoptiongrouppet=DCL:Create('b',-392,-208,r..L['GROUP_PET'],'','cr')
	DCLoptiongroupguild=DCL:Create('b',-324,-208,r..L['GROUP_GUILD'],'','cr')
	DCLoptiongroupgroup=DCL:Create('b',-256,-208,r..L['GROUP_GROUP'],'','cr')
	DCLoptiongroupchart=DCL:Create('b',-188,-208,r..L['GROUP_CHART'],'','cr')
	DCLoptiongrouptrade=DCL:Create('b',-120,-208,r..L['GROUP_TRADE'],'','cr')
	DCLoptiongroupchan=DCL:Create('b',-52,-208,r..L['GROUP_CHAN'],'','cr')
	DCLoptionguildduel=DCL:Create('b',-460,-256,r..L['GUILD_DUEL'],'','cr')
	DCLoptionguildpet=DCL:Create('b',-392,-256,r..L['GUILD_PET'],'','cr')
	DCLoptionguildguild=DCL:Create('b',-324,-256,r..L['GUILD_GUILD'],'','cr')
	DCLoptionguildgroup=DCL:Create('b',-256,-256,r..L['GUILD_GROUP'],'','cr')
	DCLoptionguildchart=DCL:Create('b',-188,-256,r..L['GUILD_CHART'],'','cr')
	DCLoptionguildtrade=DCL:Create('b',-120,-256,r..L['GUILD_TRADE'],'','cr')
	DCLoptionguildchan=DCL:Create('b',-52,-256,r..L['GUILD_CHAN'],'','cr')
	DCLoptionfriendduel=DCL:Create('b',-460,-304,r..L['FRIEND_DUEL'],'','cr')
	DCLoptionfriendpet=DCL:Create('b',-392,-304,r..L['FRIEND_PET'],'','cr')
	DCLoptionfriendguild=DCL:Create('b',-324,-304,r..L['FRIEND_GUILD'],'','cr')
	DCLoptionfriendgroup=DCL:Create('b',-256,-304,r..L['FRIEND_GROUP'],'','cr')
	DCLoptionfriendchart=DCL:Create('b',-188,-304,r..L['FRIEND_CHART'],'','cr')
	DCLoptionfriendtrade=DCL:Create('b',-120,-304,r..L['FRIEND_TRADE'],'','cr')
	DCLoptionfriendchan=DCL:Create('b',-52,-304,r..L['FRIEND_CHAN'],'','cr')
	DCLoptionbnetduel=DCL:Create('b',-460,-352,r..L['BNET_DUEL'],'','cr')
	DCLoptionbnetpet=DCL:Create('b',-392,-352,r..L['BNET_PET'],'','cr')
	DCLoptionbnetguild=DCL:Create('b',-324,-352,r..L['BNET_GUILD'],'','cr')
	DCLoptionbnetgroup=DCL:Create('b',-256,-352,r..L['BNET_GROUP'],'','cr')
	DCLoptionbnetchart=DCL:Create('b',-188,-352,r..L['BNET_CHART'],'','cr')
	DCLoptionbnettrade=DCL:Create('b',-120,-352,r..L['BNET_TRADE'],'','cr')
	DCLoptionbnetchan=DCL:Create('b',-52,-352,r..L['BNET_CHAN'],'','cr')
	DCLoptionmsgduel=DCL:Create('b',-460,-400,r..L['MSG_DUEL'],'','cr')
	DCLoptionmsgpet=DCL:Create('b',-392,-400,r..L['MSG_PET'],'','cr')
	DCLoptionmsgguild=DCL:Create('b',-324,-400,r..L['MSG_GUILD'],'','cr')
	DCLoptionmsggroup=DCL:Create('b',-256,-400,r..L['MSG_GROUP'],'','cr')
	DCLoptionmsgchart=DCL:Create('b',-188,-400,r..L['MSG_CHART'],'','cr')
	DCLoptionmsgtrade=DCL:Create('b',-120,-400,r..L['MSG_TRADE'],'','cr')
	DCLoptionmsgchan=DCL:Create('b',-52,-400,r..L['MSG_CHAN'],'','cr')
	DCLoptiongenopeninv=DCL:Create('b',-256,-456,r..L['X_DISABLE_OPENINV'],S['DOI'],'cr',-200)
	DCLoptiongenmsgs=DCL:Create('b',-256,-496,r..L['X_DISABLE_MESSAGES'],S['DDM'],'cr',-200)
	DCLoptiongendisable=DCL:Create('b',-256,-536,r..L['X_DISABLE_DECLINER'],S['DDA'],'cr',-200)

	for k1,v1 in next,defs do
		for k2 in next,v1 do
			if k1 == k2 then
				_G['DCLoption'..k1..k2]:SetScript('PostClick',function(self)
					if gsnd[k1] then StopSound(gsnd[k1]) end
					local x=random(1,55555)
					_,gsnd[k1]=PlaySoundKitID(x)
					self:SetChecked(false)
				end)
			elseif k1 ~= 'chan' and k1 ~= 'open' then
				_G['DCLoption'..k1..k2]:SetScript('PostClick',function(self)
					vars[k1][k2]=self:GetChecked()
					DCL:Register()
					DCL:BlizzOptions()
				end)
			end
		end
	end

-- the following inputbox, button, and scrolling list inspired by funkydude's BadBoy_CCleaner chat filter options

	DCLoptionOIinput=CreateFrame('EditBox',a..'OpenInvInput',DCLPanel,'InputBoxTemplate')
	DCLoptionOIinput:SetPoint('TOPRIGHT',-300,-461)
	DCLoptionOIinput:SetAutoFocus(false)
	DCLoptionOIinput:EnableMouse(true)
	DCLoptionOIinput:SetHeight(20)
	DCLoptionOIinput:SetWidth(112)
	DCLoptionOIinput:SetScript('OnEnterPressed',function()DCLoptionOIbutton:Click()end)
	DCLoptionOIinput:SetScript('OnEscapePressed',function(frame)
		frame:SetText('')
		frame:ClearFocus()
	end)
	DCLoptionOIinput:SetScript('OnEnter',function(self)
		if vars.gen.disable or vars.gen.openinv then
			GameTooltip:Hide()
		else
			GameTooltip:SetOwner(self,self.tooltipOwnerPoint or 'ANCHOR_RIGHT')
			GameTooltip:SetText(L['X_OPENINV_INPUT'],nil,nil,nil,nil,true)
		end
	end)
	DCLoptionOIinput:SetScript('OnLeave',function(self)
		GameTooltip:Hide()
	end)

	DCLoptionOIbutton=CreateFrame('Button',a..'OpenInvButton',DCLPanel,'UIPanelButtonTemplate')
	DCLoptionOIbutton:SetPoint('TOPRIGHT',DCLoptionOIinput,'BOTTOMRIGHT',1,0)
	DCLoptionOIbutton:SetPoint('TOPLEFT',DCLoptionOIinput,'BOTTOMLEFT',-6,0)
	DCLoptionOIbutton:SetNormalFontObject('GameFontNormalSmall')
	DCLoptionOIbutton:SetHighlightFontObject('GameFontHighlightSmall')
	DCLoptionOIbutton:SetDisabledFontObject('GameFontDisableSmall')
	DCLoptionOIbutton:SetText(S['ADR'])
	DCLoptionOIbutton:SetScript('OnClick',function()
		DCLoptionOIinput:ClearFocus()
		local t=DCLoptionOIinput:GetText()
		if t == '' or t:find('^ *$') then DCLoptionOIinput:SetText('') return end
		local found
		for i=1,#vars.open do
			if vars.open[i] == t then found=i end
		end
		if found then tremove(vars.open,found)
		else tinsert(vars.open,t) end
		DCL:SetOpenInvList()
		DCLoptionOIinput:SetText('')
	end)
	DCLoptionOIbutton:SetScript('OnEnter',function(self)
		if vars.gen.disable or vars.gen.openinv then
			GameTooltip:Hide()
		else
			GameTooltip:SetOwner(self,self.tooltipOwnerPoint or 'ANCHOR_RIGHT',-1)
			GameTooltip:SetText(L['X_OPENINV_BUTTON'],nil,nil,nil,nil,true)
		end
	end)
	DCLoptionOIbutton:SetScript('OnLeave',function(self)
		GameTooltip:Hide()
	end)

	DCLoptionOIdrop=CreateFrame('Frame',a..'OpenInvDropDown',DCLPanel,'UIDropDownMenuTemplate')
	DCLoptionOIdrop:SetPoint('TOPLEFT',DCLoptionOIbutton,'BOTTOMLEFT',-16,0)
	UIDropDownMenu_SetWidth(DCLoptionOIdrop,100)
	UIDropDownMenu_SetText(DCLoptionOIdrop,S['CHS'])
	UIDropDownMenu_Initialize(DCLoptionOIdrop,function(frame)
		local info=UIDropDownMenu_CreateInfo()
		info.func=function(self,arg1)vars.chan[arg1]=not vars.chan[arg1]end
		info.text,info.checked,info.arg1=S['EMO'],vars.chan.emote,'emote'
		UIDropDownMenu_AddButton(info)
		info.text,info.checked,info.arg1=S['SAY'],vars.chan.say,'say'
		UIDropDownMenu_AddButton(info)
		info.text,info.checked,info.arg1=S['YEL'],vars.chan.yell,'yell'
		UIDropDownMenu_AddButton(info)
		info.text,info.checked,info.arg1=S['GEN'],vars.chan[1],1
		UIDropDownMenu_AddButton(info)
		info.text,info.checked,info.arg1=S['TRA'],vars.chan[2],2
		UIDropDownMenu_AddButton(info)
		info.text,info.checked,info.arg1=S['LFG'],vars.chan[26],26
		UIDropDownMenu_AddButton(info)
	end)
	DCLoptionOIdrop:SetScript('OnEnter',function(self)
		if vars.gen.disable or vars.gen.openinv then
			GameTooltip:Hide()
		else
			GameTooltip:SetOwner(self,self.tooltipOwnerPoint or 'ANCHOR_RIGHT',-16)
			GameTooltip:SetText(L['X_OPENINV_MENU'],nil,nil,nil,nil,true)
		end
	end)
	DCLoptionOIdrop:SetScript('OnLeave',function(self)
		GameTooltip:Hide()
	end)

	DCLoptionOIback=CreateFrame('Frame',a..'OpenInvBackdrop',DCLPanel)
	DCLoptionOIback:SetPoint('TOPRIGHT',DCLoptionOIinput,'TOPLEFT',-24,0)
	DCLoptionOIback:SetPoint('BOTTOMLEFT',DCLoptionOIdrop,'BOTTOMLEFT',-119,6)
	DCLoptionOIback:SetBackdrop({
		bgFile='Interface\\Tooltips\\UI-Tooltip-Background',
		edgeFile='Interface\\Tooltips\\UI-Tooltip-Border',
		tile=true,tileSize=8,edgeSize=8,
		insets={left=2,right=2,top=2,bottom=2}})
	DCLoptionOIback:SetBackdropColor(0,0,0,.75)
	DCLoptionOIback:SetBackdropBorderColor(.25,.25,.25)
	DCLoptionOIback:SetScript('OnEnter',function(self)
		if vars.gen.disable or vars.gen.openinv then
			GameTooltip:Hide()
		else
			GameTooltip:SetOwner(self,self.tooltipOwnerPoint or 'ANCHOR_RIGHT')
			GameTooltip:SetText(L['X_OPENINV_LIST'],nil,nil,nil,nil,true)
		end
	end)
	DCLoptionOIback:SetScript('OnLeave',function(self)
		GameTooltip:Hide()
	end)

	DCLoptionOIscroll=CreateFrame('ScrollFrame',a..'OpenInvScroll',DCLPanel,'UIPanelScrollFrameTemplate')
	DCLoptionOIscroll:SetPoint('LEFT',DCLoptionOIback,'LEFT',4.5,0)
	DCLoptionOIscroll:SetPoint('RIGHT',DCLoptionOIback,'RIGHT',-4.5,0)
	DCLoptionOIscroll:SetPoint('TOP',DCLoptionOIback,'TOP',0,-4)
	DCLoptionOIscroll:SetPoint('BOTTOM',DCLoptionOIback,'BOTTOM',0,4)

	DCLoptionOIlist=CreateFrame('EditBox',a..'OpenInvList',DCLPanel)
	DCLoptionOIlist:SetMaxLetters(1000)
	DCLoptionOIlist:SetAutoFocus(false)
	DCLoptionOIlist:EnableMouse(false)
	DCLoptionOIlist:SetMultiLine(true)
	DCLoptionOIlist:SetWidth(120)
	DCLoptionOIlist:Show()

	DCLoptionOIscroll:SetScrollChild(DCLoptionOIlist)

	DCLPanel.okay=function()
		Decliner_SV=nil
		Decliner_SV=tcopy(vars)
		Decliner_SV.check=true
		notemp=true
	end
	DCLPanel.cancel=function()
		vars=tcopy(temp)
		DCL:Register()
		notemp=true
	end
	DCLPanel.default=function()
		vars=tcopy(defs)
		Decliner_SV=nil
		Decliner_SV=tcopy(defs)
		Decliner_SV.check=true
		DCL:SetOpenInvList()
		DCL:SetCheckBoxes()
		DCL:BlizzOptions()
	end
	DCLPanel.refresh=function()
		DCL:SetOpenInvList()
		DCL:SetCheckBoxes()
		DCL:BlizzOptions()
		if notemp then temp=tcopy(vars) notemp=false end
	end
	SLASH_DECLINER_1='/decliner'
	SLASH_DECLINER_2='/decline'
	SLASH_DECLINER_3='/dcl'
	SlashCmdList['DECLINER_']=function(arg)
		if arg == 'debug' then
			if dcldebug then
				dcldebug=false
				DCL:Print('debug off')
			else
				dcldebug=true
				DCL:Print('debug on')
			end
		else
	-- thank you to https://www.townlong-yak.com/framexml/bugs/6 for this extremely simple workaround
			InterfaceOptionsFrame_OpenToCategory(a)
			InterfaceOptionsFrame_OpenToCategory(a)
		end
	end
end